#include <suifkernel/suif_env.h>
#include <suifkernel/module_subsystem.h>
#include <suifkernel/module.h>
#include <suifpasses/passes.h>
#include <basicnodes/basic.h>
#include <iostream>
#include "print.h"

class Suif2StrlPass : public Pass {
public:
  Suif2StrlPass(SuifEnv *env, const LString &name = "suif2strl")
    : Pass(env, name) {}

  ~Suif2StrlPass() {}

  Module *clone() const { return (Module*)this; }
  void initialize();

  /// Does the work
  void do_file_set_block(FileSetBlock*);

};

void Suif2StrlPass::initialize()
{
  Pass::initialize();
}

void Suif2StrlPass::do_file_set_block(FileSetBlock *fsb)
{
  EsterelPrinter ep(get_suif_env());

  ep.fileSetBlock(fsb);
  std::cout << ep.result << endl;
}

extern "C" void init_suif2strl(SuifEnv *suif_env)
{
  init_suifnodes(suif_env);
  init_basicnodes(suif_env);
  init_esuifnodes(suif_env);

  ModuleSubSystem *ms = suif_env->get_module_subsystem();
  if (!ms->retrieve_module("suif2strl"))
    ms->register_module(new Suif2StrlPass(suif_env, "suif2strl"));
}
